<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_details".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderDetails".
 *
 * Columns in table "provider_details" available as properties of the model,
 * followed by relations of table "provider_details" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property string $nppes_enumeration_date
 * @property string $nppes_last_updated_date
 * @property integer $philosophy_id
 * @property integer $has_financing_plans
 * @property integer $has_sliding_billing
 * @property integer $has_medications
 * @property string $date_birth
 * @property string $dea_number
 * @property string $licence_number
 * @property string $email
 * @property string $system_email
 * @property string $no_insurance_reason
 * @property string $pb_account
 * @property string $pb_user
 * @property integer $schedule_mail_enabled
 * @property integer $in_person_booking
 * @property integer $telemedicine_booking
 * @property integer $schedule_mail_days
 * @property string $score_missing_data
 * @property integer $telemedicine_enabled
 * @property integer $telemedicine_accept_new_patients
 * @property integer $telemedicine_enabled_by_account_id
 * @property integer $telemedicine_disabled_by_account_id
 *
 * @property Provider $provider
 * @property Philosophy $philosophy
 */
abstract class BaseProviderDetails extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_details';
    }

    public static function representingColumn()
    {
        return 'email';
    }

    public function rules()
    {
        return array(
            array('provider_id', 'required'),
            array('provider_id, philosophy_id, has_financing_plans, has_sliding_billing, has_medications, schedule_mail_enabled, in_person_booking, telemedicine_booking, telemedicine_enabled, telemedicine_accept_new_patients, telemedicine_enabled_by_account_id, telemedicine_disabled_by_account_id', 'numerical', 'integerOnly' => true),
            array('dea_number', 'length', 'max' => 4, 'min' => 4),
            array('licence_number', 'length', 'max' => 25),
            array('email, system_email', 'length', 'max' => 254),
            array('personal_phone_number', 'length', 'max' => 14),
            array('email', 'email', 'message' => 'Please enter a valid email'),
            array('pb_account', 'length', 'max' => 45),
            array('pb_user', 'length', 'max' => 11),
            array('schedule_mail_days', 'length', 'max' => 10),
            array('nppes_enumeration_date, nppes_last_updated_date, date_birth, no_insurance_reason, score_missing_data', 'safe'),
            array('accepts_government_insurances, nppes_enumeration_date, nppes_last_updated_date, philosophy_id, has_financing_plans, has_sliding_billing, has_medications, date_birth, dea_number, licence_number, email, system_email, personal_phone_number, no_insurance_reason, pb_account, pb_user, schedule_mail_enabled, in_person_booking, telemedicine_booking, schedule_mail_days, score_missing_data, telemedicine_enabled, telemedicine_accept_new_patients, telemedicine_enabled_by_account_id, telemedicine_disabled_by_account_id', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, provider_id, nppes_enumeration_date, nppes_last_updated_date, philosophy_id, has_financing_plans, has_sliding_billing, has_medications, date_birth, dea_number, licence_number, email, system_email, personal_phone_number, no_insurance_reason, pb_account, pb_user, schedule_mail_enabled, in_person_booking, telemedicine_booking, schedule_mail_days, score_missing_data, telemedicine_enabled, telemedicine_accept_new_patients, telemedicine_enabled_by_account_id, telemedicine_disabled_by_account_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'philosophy' => array(self::BELONGS_TO, 'Philosophy', 'philosophy_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => Yii::t('app', 'Provider'),
            'nppes_enumeration_date' => Yii::t('app', 'Nppes Enumeration Date'),
            'nppes_last_updated_date' => Yii::t('app', 'Nppes Last Updated Date'),
            'philosophy_id' => Yii::t('app', 'Philosophy'),
            'has_financing_plans' => Yii::t('app', 'Has Financing Plans'),
            'has_sliding_billing' => Yii::t('app', 'Has Sliding Billing'),
            'has_medications' => Yii::t('app', 'Has Meds'),
            'date_birth' => Yii::t('app', 'DOB'),
            'dea_number' => Yii::t('app', 'DEA #'),
            'licence_number' => Yii::t('app', 'License #'),
            'email' => Yii::t('app', 'Email'),
            'personal_phone_number' => Yii::t('app', 'Personal Phone Number'),
            'system_email' => Yii::t('app', 'System Email'),
            'no_insurance_reason' => Yii::t('app', 'No Insurance Reason'),
            'pb_account' => Yii::t('app', 'PB Account'),
            'pb_user' => Yii::t('app', 'PB User'),
            'schedule_mail_enabled' => Yii::t('app', 'Schedule Mail Enabled'),
            'in_person_booking' => Yii::t('app', 'In Person Booking'),
            'telemedicine_booking' => Yii::t('app', 'Telemedicine Booking'),
            'schedule_mail_days' => Yii::t('app', 'Schedule Mail Days'),
            'accepts_government_insurances' => Yii::t('app', 'Accepts Government Insurances'),
            'adenhance_url' => Yii::t('app', 'Adenhance Url'),
            'score_missing_data' => Yii::t('app', 'Score Missing Data'),
            'telemedicine_enabled' => Yii::t('app', 'Telemedicine Enabled'),
            'telemedicine_accept_new_patients' => Yii::t('app', 'Telemedicine Accept New Patients'),
            'telemedicine_enabled_by_account_id' => Yii::t('app', 'Telemedicine Enabled By Account Id'),
            'telemedicine_disabled_by_account_id' => Yii::t('app', 'Telemedicine Disabled By Account Id')
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->with = array('provider');

        $criteria->compare('id', $this->id);
        //$criteria->compare('provider_id', $this->provider_id);

        if (!intval($this->provider_id) && is_string($this->provider_id) && strlen($this->provider_id) > 0) {
            $criteria->compare('provider.first_last', $this->provider_id, true);
        } elseif (intval($this->provider_id)) {
            $criteria->compare('provider_id', $this->provider_id);
        }

        $criteria->compare('nppes_enumeration_date', $this->nppes_enumeration_date, true);
        $criteria->compare('nppes_last_updated_date', $this->nppes_last_updated_date, true);
        $criteria->compare('philosophy_id', $this->philosophy_id);
        $criteria->compare('has_financing_plans', $this->has_financing_plans);
        $criteria->compare('has_sliding_billing', $this->has_sliding_billing);
        $criteria->compare('has_medications', $this->has_medications);
        $criteria->compare('date_birth', $this->date_birth, true);
        $criteria->compare('dea_number', $this->dea_number);
        $criteria->compare('licence_number', $this->licence_number, true);
        $criteria->compare('email', $this->email, true);
        $criteria->compare('system_email', $this->system_email, true);
        $criteria->compare('personal_phone_number', $this->personal_phone_number, true);
        $criteria->compare('no_insurance_reason', $this->no_insurance_reason, true);
        $criteria->compare('t.pb_account', $this->pb_account, true);
        $criteria->compare('pb_user', $this->pb_user, true);
        $criteria->compare('schedule_mail_enabled', $this->schedule_mail_enabled);
        $criteria->compare('in_person_booking', $this->in_person_booking);
        $criteria->compare('telemedicine_booking', $this->telemedicine_booking);
        $criteria->compare('schedule_mail_days', $this->schedule_mail_days, true);
        $criteria->compare('score_missing_data', $this->score_missing_data, true);
        $criteria->compare('telemedicine_enabled', $this->telemedicine_enabled);
        $criteria->compare('telemedicine_accept_new_patients', $this->telemedicine_accept_new_patients);
        $criteria->compare('telemedicine_enabled_by_account_id', $this->telemedicine_enabled_by_account_id);
        $criteria->compare('telemedicine_disabled_by_account_id', $this->telemedicine_disabled_by_account_id);

        return new CActiveDataProvider(get_class($this), array('criteria' => $criteria, 'pagination' => array('pageSize'
                => 100)));
    }

    /**
     * @todo document
     * @return \CActiveDataProvider
     */
    public function searchPB()
    {
        $criteria = new CDbCriteria;

        $criteria->with = array('provider');
        if (!intval($this->provider_id) && is_string($this->provider_id) && strlen($this->provider_id) > 0) {
            $criteria->compare('provider.first_last', $this->provider_id, true);
        } elseif (intval($this->provider_id)) {
            $criteria->compare('provider_id', $this->provider_id);
        }
        $criteria->compare('t.pb_account', $this->pb_account, true);
        $criteria->addCondition('(pb_account IS NOT NULL) AND (pb_user IS NOT NULL)');

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderDetail|ProviderDetails', $n);
    }

}
